unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Button6: TButton;
    Edit5: TEdit;
    Edit10: TEdit;
    Button7: TButton;
    Edit6: TEdit;
    Edit7: TEdit;
    Panel3: TPanel;
    Edit1: TEdit;
    Button4: TButton;
    ListBox1: TListBox;
    Panel4: TPanel;
    Button8: TButton;
    Edit8: TEdit;
    Button2: TButton;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

  trec = record
         lettre : char ;
         fin : byte ;
         droite,bas : longint ;
         end ;

  dictionnaire = record
    t : array[1..5000] of trec ;
    derniere_case : longint ;
    end ;

var
  Form1: TForm1;
  dico : dictionnaire ;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
close ;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
listbox1.items.loadFromFile(edit1.text) ;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
end;

//================ dbut dictionnaires =============
procedure introduis_mot_fin_dico(mot : string ;p : longint;bas : boolean) ;
var l,courant : longint ;
begin
if bas
   then dico.t[p].bas:=dico.derniere_case
   else dico.t[p].droite:=dico.derniere_case ;
l:=length(mot) ;
for courant:=1 to l do
    with dico.t[dico.derniere_case+courant-1] do
       begin
       lettre:=mot[courant] ;
       fin:=0 ;
       droite:=dico.derniere_case+courant ;
       bas:=0 ;
       end ;
dico.t[dico.derniere_case+l-1].droite:=0 ;  // plus rien derrire
dico.t[dico.derniere_case+l-1].fin:=1 ;  // c'est un mot
inc(dico.derniere_case,l) ;
end ;

function positionnement_sur_lettre(lettre : char ;courant : longint ;
    var dernier : longint ) : longint ;
var l : char ;
begin
l:=dico.t[courant].lettre ;
if (courant>0) and (l=lettre) then dernier:=courant ;
while (courant<>0) and (l<>lettre) do
   begin
   courant:=dico.t[courant].bas ;
   l:=dico.t[courant].lettre ;
   if (courant>0)
       and (l=lettre)
      then dernier:=courant ;  // mmorise la dernire position trouve o l=lettre}
   end ;
positionnement_sur_lettre:=courant ;
end ;

procedure rajoute_mot(mot : string) ;
var i,l,courant,p,precedent,dernier : longint ;
    dedans : boolean ;
begin      
l:=length(mot) ;courant:=1 ;i:=1 ;dernier:=0 ;
p:=positionnement_sur_lettre(mot[1],1,dernier) ;
dedans:=true ;  // pour les mots ne contenant qu'une lettre ; a ne marchait pas au dbut du while
while (i<=l) and (p>0) and
      (dedans) and
      (courant>0) and     
      (i<dico.derniere_case) do
   begin                  
   p:=positionnement_sur_lettre(mot[i],courant,dernier) ;
   if p>0 then courant:=dico.t[p].droite ;
   dedans:=(dernier+1)<dico.derniere_case ;
   inc(i) ;
   end ;
if courant>0 then  //donc p=0
   begin
   dec(i) ;
   if dernier=0 then  // cas spcial
      begin
      if dico.derniere_case=1 then
         introduis_mot_fin_dico(mot,1,false)
      else
         begin  // positionnement sur la dernire lettre de la colonne d'un arbre
         p:=courant ;
         while p<>0 do  // positionnement sur la dernire lettre de la colonne d'un arbre
            begin
            p:=dico.t[p].bas ;
            if p>0 then courant:=p ;
            end ;
         introduis_mot_fin_dico(mot,courant,true)
         end ;
      end
   else
      if dernier+1=dico.derniere_case then
         if mot[i]=dico.t[dernier].lettre then
            introduis_mot_fin_dico(copy(mot,i,l),dernier,false)
         else
            introduis_mot_fin_dico(copy(mot,i,l),dernier,true)
      else
         begin
         p:=courant ;
         while p<>0 do  // positionnement sur la dernire lettre de la colonne d'un arbre
            begin
            p:=dico.t[p].bas ;
            if p>0 then courant:=p ;
            end ;
         introduis_mot_fin_dico(copy(mot,i,l),courant,true) ;
         end ;
   end
else  // donc p<>0
   introduis_mot_fin_dico(copy(mot,i,l),dernier,false)
end ;

function appartient(mot : string) : boolean ;
var i,l,courant,p : longint ;
    dernier : longint ;
begin
courant:=1 ;i:=1 ;p:=1 ;l:=length(mot) ;
while (i<=l) and (p>0) do
   begin
   p:=positionnement_sur_lettre(mot[i],courant,dernier) ;
   if p>0 then courant:=dico.t[p].droite ;
   inc(i) ;
   end ;
appartient:=(i>l) and (p>0) and (dico.t[p].fin=1) ;
end ;

//=========== fin dictionnaires ===========
// mettre liste dans dico
// la liste doit tre trie par ordre alphabtique
procedure TForm1.Button6Click(Sender: TObject);
var i,c : longint ;
begin
dico.derniere_case:=1 ;
c:=listbox1.items.count ;
for i:=0 to c-1 do
    begin
    rajoute_mot(listbox1.items[i]) ;
    if i mod 100=0 then
       begin
       edit5.text:=intToStr(i) ;edit5.refresh ;
       edit10.text:=intToStr(dico.derniere_case) ;edit10.refresh ;
       end ;
    end ;
edit5.text:=listBox1.items[i-1] ;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
if appartient(edit6.text) then edit7.text:='oui' else edit7.text:='non' ;
end;

procedure TForm1.Button8Click(Sender: TObject);
var i : integer ;
    st : string ;
begin
st:='' ;
for i:=1 to 50 do
    st:=st+dico.t[i].lettre ;
edit8.text:=st ;
end;

end.
